Description

Currently the ChangeDetail data structure is

type ChangeDetail struct ({
Field string " Json:"field"®
0ldval any ‘json:"old_value"®
NewVal any ‘json:"new_value"®

The OldVal and NewVal fields need to be changed to strings.

Associated revisions

Revision d2b52534 - 04/04/2024 08:57 PM - Sachin Divekar

Refactor ChangeDetail to store values as strings refs #18072

It is a critical refactor to the ChangeDetail struct and related methods to ensure that all values are stored as strings. Previously, the OldVal and
NewVal fields in the ChangeDetail struct were of type any, which allowed for flexibility but complicated the serialization process and could lead to
inconsistencies in log storage.

Changes include:

e Modifying the ChangeDetail struct to have OldVal and NewVal fields as strings instead of any.

e Introducing a convertToString utility function that converts any value to its JSON string representation. This function is used internally when
creating or adding changes to ensure all values are consistently stored as strings.

¢ Updating the NewChangeDetail function and AddChange method to use convertToString for value conversion. This approach maintains the
flexibility of logging changes without enforcing a strict type constraint on the values being logged.

¢ Error handling in convertToString has been designed to write errors directly to os.Stderr. This decision was made to avoid complicating the API
with error handling for what is expected to be a rare event, allowing the calling code to proceed while still logging the conversion error.

Revision 97461883 - 09/04/2024 01:45 PM - Sachin Divekar

Refactor ChangeDetail to store values as strings refs #18072

History

#1 - 26/03/2024 07:33 PM - Shuvam Misra
- Target version changed from Sprint 29 Mar to Sprint 12 Apr

#2 - 04/04/2024 05:16 PM - Sachin Divekar

- Status changed from New to In Progress

#3 - 05/04/2024 12:39 PM - Sachin Divekar

- % Done changed from 0 to 90

- Due date changed from 29/03/2024 to 12/04/2024

Instead of changing the struct | have modified the function that creates change logentry to convert the values to their JSON string representation.

| have added a new private utility function func convertToString(value any) string. This function is used internally when creating or adding changes.

Error handling in convertToString has been designed to write errors directly to os.Stderr. This simplifies the functional API for what is expected to be a
rare event, allowing the calling code to proceed while still logging the conversion error.
#4 - 07/04/2024 09:18 PM - Sachin Divekar
- % Done changed from 90 to 100

- Status changed from In Progress to Testing

#5 - 09/04/2024 01:51 PM - Sachin Divekar

- Status changed from Testing to Closed
